class NumberReader2 implements Iterable<Integer> {
	private String filename;
	public NumberReader2(String filename) {
		this.filename = filename;
	}
	public Iterator<Integer> iterator() {
		return new NumberIterator(filename);
	}
	class NumberIterator implements Iterator<Integer> {
		NumberIterator(String filename) {
			In.open(filename);
		}
		public void remove() {
			throw new UnsupportedOperationException();
		}
		public boolean hasNext() {
			In.peek();
			return In.done();
		}
		public Integer next() {
			return In.readInt();
		}
	}
	public static void main(String[] args) {
		NumberReader2 reader = new NumberReader2("numbers.txt");
		for(Integer x: reader)
			Out.print(x + " ");
		Out.println();
	}
}